data(iris)

library(ggplot2)

p <- ggplot(data=iris, aes(x=Species, y=Petal.Length))

p + geom_boxplot()

# Test de Levene

medianas <- tapply(iris$Petal.Length, iris$Species, median, na.rm=T)

desviaciones <- abs(iris$Petal.Length -  medianas[iris$Species])

g <- lm(desviaciones ~ iris$Species)
anova(g)

library(car)
leveneTest(y = iris$Petal.Length, group = iris$Species, center = "median")

## https://cienciadedatos.net/documentos/9_homogeneidad_de_varianza_homocedasticidad