# https://www.guru99.com/r-apply-sapply-tapply.html

library(MASS)
data(Cars93)
mydata <- Cars93[,4:6]

# apply() function
m <- apply(mydata, MARGIN = 2, FUN = max)
m

# lapply() function
movies <- c("SPYDERMAN","BATMAN","VERTIGO","CHINATOWN")
movies_lower <- lapply(movies, tolower)
class(movies_lower)
str(movies_lower)

movies_lower <- unlist(movies_lower)
class(movies_lower)
movies_lower

# sapply() function
mydata <- Cars93[,c("MPG.city","MPG.highway")]
list_MPG   <- lapply(mydata, min)
vector_MPG <- sapply(mydata, min)
class(list_MPG)
class(vector_MPG)

avg <- function(x) {  
  ( min(x) + max(x) ) / 2}
avg_cars <- sapply(mydata, avg)
avg_cars

below_ave <- function(x) {  
  ave <- mean(x) 
  return(x[x > ave])
}
mpg_s<- sapply(Cars93$MPG.city, below_ave)
mpg_l<- lapply(Cars93$MPG.city, below_ave)
identical(mpg_s, mpg_l)

# tapply() function
tapply(Cars93$MPG.city, Cars93$Type, median)




